<script>
	export { className as class }
	export let modal = false
	export let open = false

	let className = ""

	import { createEventDispatcher } from "svelte"
	import { fade } from "svelte/transition"
	import clsx from "clsx"
	import SvgIcon from "./SvgIcon.svelte"
	import { x } from "~/heroicons.js"

	const dispatch = createEventDispatcher()

	$: classes = clsx(
		"h-screen top-0 overflow-auto",
		// z-index is defined only in modal mode, otherwise tooltips are below sidebar in desktop mode.
		modal ? "z-20 fixed max-w-full shadow-2xl" : "sticky",
		open || "hidden",
		className,
	)

	function handleKeydown(event) {
		if (event.key === "Escape") {
			close()
		}
	}

	function close() {
		dispatch("close")
	}
</script>

<svelte:window on:keydown={handleKeydown} />

{#if open && modal}
	<!-- overlay -->
	<div
		class="z-10 fixed inset-0 bg-black bg-opacity-50"
		transition:fade
		on:click={close}>
		{#if modal}
			<button
				class="absolute m-4 right-0 text-toutafrique-gray"
				on:click={close}>
				<SvgIcon size={24} {...x} />
			</button>
		{/if}
	</div>
{/if}

<div
	class={classes}
	style={modal ? 'max-width: calc(100% - 30px);' : 'min-width: 15rem;'}>
	<slot {close} />
</div>
